BeginPackage["QQbarThreshold`"];
Unprotect["QQbarThreshold`*"];

LoadGrid::usage = "LoadGrid[gridfile] loads a gridfile"<>
" for numerical evaluations of the NNLO and NNNLO cross sections.";
LoadNonresonantGrid::usage = "LoadNonresonantGrid[gridfile] loads a gridfile"<>
" for numerical evaluations of the non-resonant contribution"<>
" to the top cross section.";
GridDirectory::usage = "The directory containing the default grids";
GridEtMin::usage = "The minimum rescaled energy Et = -4/(alphaS^2*cF^2*m)*Energy"<>
" for the currently loaded grid.";
GridEtMax::usage = "The maximum rescaled energy Et = -4/(alphaS^2*cF^2*m)*Energy"<>
" for the currently loaded grid.";
GridGammatMin::usage = "The minimum rescaled width Gammat = -4/(alphaS^2*cF^2*m)*Width"<>
" for the currently loaded grid.";
GridGammatMax::usage = "The maximum rescaled width Gammat = -4/(alphaS^2*cF^2*m)*width"<>
" for the currently loaded grid.";

ConvertGrid::usage = "ConvertGrid[oldgrid, newgrid] converts a grid file "<>
"oldgrid created by TTbarGridCalc to a grid file newgrid suitable for LoadGrid";

BBbarXSection::usage = "BBbarXSection[E, mu, mb, ord] gives the bottom"<>
" production cross section at the center-of-mass energy E,"<>
" renormalisation scale mu and mass mb at order ord between 0 and 3.";
TTbarXSection::usage = "TTbarXSection[E, {muSoft, muWeak}, {mt, width}, ord]"<>
" gives the top production cross section at the center-of-mass energy E,"<>
" soft renormalisation scale muSoft, weak scale muWeak, mass mt and the given width at order ord (\"LO\", \"NLO\", \"N2LO\", or \"N3LO\").";
BBbarRRatio::usage = "BBbarRRatio[E, mu, mb, ord] gives the bottom"<>
" contribution to the hadronic R ratio at the center-of-mass energy E,"<>
" renormalisation scale mu and mass mb at order ord between 0 and 3.";
TTbarRRatio::usage = "TTbarRRatio[E, {muSoft, muWeak}, {mt, width}, ord] gives"<>
" the top contribution to the hadronic R ratio at the center-of-mass energy E,"<>
" soft renormalisation scale muSoft, weak scale muWeak, mass mt and the given width at order ord (\"LO\", \"NLO\", \"N2LO\", or \"N3LO\").";

BBbarEnergyLevel::usage = "BBbarEnergyLevel[n, mu, mb, ord] gives"<>
" the binding energy of S-wave quarkonium. n is the principal"<>
" quantum number, mu the renormalisation scale, mb the bottom mass"<>
" and ord the perturbative order \"LO\", \"NLO\", \"N2LO\", or \"N3LO\".";
TTbarEnergyLevel::usage = "TTbarEnergyLevel[n, mu, mt, ord] gives"<>
" the binding energy of S-wave quarkonium. n is the principal"<>
" quantum number, mu the renormalisation scale, mt the top mass"<>
" and ord the perturbative order \"LO\", \"NLO\", \"N2LO\", or \"N3LO\".";

BBbarResidue::usage = "BBbarResidue[n, mu, mb, ord] gives"<>
" the residue of an S-wave quarkonium bound state. n is the principal"<>
" quantum number, mu the renormalisation scale, mb the bottom mass"<>
" and ord the perturbative order \"LO\", \"NLO\", \"N2LO\", or \"N3LO\".";
TTbarResidue::usage = "TTbarResidue[n, mu, mb, ord] gives"<>
" the residue of an S-wave quarkonium bound state. n is the principal"<>
" quantum number, mu the renormalisation scale, mt the top mass"<>
" and ord the perturbative order \"LO\", \"NLO\", \"N2LO\", or \"N3LO\".";

TopWidth::usage =
"TopWidth[mu, mt, o] gives the decay width of the top quark"<>
" with a mass mt at the scale mu and order o.";

alphaSBottom::usage = "alphaSBottom[mu] gives the strong coupling constant"<>
" at the scale mu as used for bottom-related functions."<>
" alphaSBottom[mu, alphaSmZ] performs evolution and decoupling from"<>
" the given value alphaSmZ for the strong coupling at the Z pole."<>
" alphaSBottom[mu, {mu0, alphaSmu0}] takes alphaSmu0as the input value "<>
" for the strong coupling at the scale mu0.";
alphaSTop::usage = "alphaSTop[mu] gives the strong coupling constant"<>
" at the scale mu as used for top-related functions."<>
" alphaSTop[mu, alphaSmZ] performs evolution from"<>
" the given value alphaSmZ for the strong coupling at the Z pole."<>
" alphaSTop[mu, {mu0, alphaSmu0}] takes alphaSmu0as the input value "<>
" for the strong coupling at the scale mu0.";

alphaSmu0::usage = "Option for cross section, energy level and residue"<>
" functions. alphaSmu0 -> {mu0, alphaS} specifies a reference scale mu0"<>
" and value of the strong coupling constant at the scale mu0."<>
" If set, this option overrides the alphaSmZ option.";
alphaSmZ::usage = "Option for cross section, energy level and residue"<>
" functions. Specifies the value of the strong coupling constant at the scale mZ.";

DoubleLightInsertion::usage = "Option for energy level and residue functions."<>
"Specifies whether effects from a non-zero light quark mass on "<>
"double potential insertions are taken into account. Setting this "<>
"option to True usually has a small numerical impact on the final result "<>
"and leads to a slowdown of about an order of magnitude."

YukawaFactor::usage =
"Option for cross section, energy level and residue functions."<>
" Specifies a multiplier for the quark Yukawa coupling.";
mHiggs::usage =
"Option for cross section, energy level and residue functions."<>
" Specifies the Higgs boson mass.";
InvariantMassCut::usage =
"Option for cross section functions."<>
"Specifies an invariant mass cut for the non-resonant contribution."<>
"The invariant mass of the quark-antiquark pair will be restricted"<>
"to the region between m - <value> and m + <value>."<>
"If set to Automatic the loosest possible cut value m - mW is taken,"<>
"which yields the total cross section.";

BeyondQCD::usage =
"Option for cross section, energy level and residue functions."<>
" Specifies correction beyond QCD that should be included. Possible settings are"<>
" None, \"None\", \"QED\", \"Higgs\", \"All\", All,"<>
" or the List {\"QED\", \"Higgs\"}  (equivalently {\"QED\", \"Higgs\"})."<>
" It is also permitted to specify a List with a single entry. "<>
" All (or \"All\") includes QED, Higgs and electroweak corrections. "<>
" The nonresonant contribution to the cross section is controlled "<>
" by the separate ResonantOnly option.";

alpha::usage =  "Option for cross section, energy level and residue functions."<>
" Specifies the running QED coupling constant.";
muAlpha::usage =  "Option for cross section, energy level and residue functions."<>
" Specifies the scale of for running QED coupling constant.";
ml::usage = "Option for all bottom or top related functions."<>
" Specifies the mass of the heaviest light quark."<>
" (implementation incomplete)";
r4::usage = "Option for cross section, energy level and residue functions."<>
" Specifies an approximate value for the highest-order conversion between"<>
" the pole and the MS scheme.";
MassScheme::usage =
"Option for cross section, energy level and residue functions."<>
" The first element specifies the mass scheme (one of"<>
" \"Pole\", \"PS\", \"PSshift\", \"1S\", \"1Sshift\", \"MSshift\")."<>
" For the \"PS\", \"PSshift\", and \"MSshift\" schemes there should be"<>
" a second element that specifies the corresponding scale.";
Production::usage = "Option for cross section functions."<>
" Specifies production channels to be taken into account."<>
" If set to \"PhotonOnly\", only production via a virtual photon"<>
" is considered. \"SWaveOnly\" additionally takes into account"<>
" S-wave production via a Z boson. All (default) includes all possible"<>
" channels.";
ResumPoles::usage = "Option for cross section functions."<>
" Specifies the number of bound states that are resummed"<>
" into the Green function.";
ExpandEnergyFactor::usage = "Option for cross section and residue functions."<>
" Specifies whether the global factor 1/s in the polarisation function"<>
" is expanded around the threshold center-of-mass energy.";
ResonantOnly::usage = "Option for cross section functions."<>
" Specifies whether only the resonant production should be computed.";

Contributions::usage =
"Option for cross section, energy level and residue functions."<>
" Specifies the potential insertion corrections and matching coefficients"<>
" that are taken into account."<>
" Contributions -> All is equvialent to Contributions -> AllContributions."<>
" See also: AllContributions, NoContributions, ExceptContributions, OnlyContributions";
vCoulomb::usage = "Specifies which orders of the Coulomb potential"<>
" are taken into account.";
vdelta::usage = "Specifies which orders of the delta potential"<>
" are taken into account."
vr2inv::usage = "Specifies which orders of the 1/r^2 potential"<>
" are taken into account.";
vp2::usage = "Specifies which orders of the momentum dependent potential"<>
" are taken into account."
vkinetic::usage = "Specifies which kinetic corrections"<>
" are taken into account.";
ultrasoft::usage = "Specifies which orders of the ultrasoft correction"<>
" are taken into account.";
vHiggs::usage = "Specifies which orders of the Higgs potential"<>
" are taken into account.";
vQEDCoulomb::usage = "Specifies which orders of the QED Coulomb potential"<>
" are taken into account.";
cv::usage = "Specifies which orders of the hard current matching coefficient"<>
" are taken into account.";
cvHiggs::usage = "Specifies which orders of the Higgs correction to the"<>
" hard current matching coefficient are taken into account.";
CvQED::usage = "Specifies whether pure QED corrections with vector coupling"<>
" to the initial-state leptons should be taken into account.";
CaQED::usage = "Specifies whether pure QED corrections with axialvector coupling"<>
" to the initial-state leptons should be taken into account.";
CvWZ::usage = "Specifies whether corrections with vector coupling"<>
" to the initial-state leptons involving at least one W, Z, "<>
" or Goldstone boson should be taken into account.";
CaWZ::usage = "Specifies whether corrections with axialvector coupling"<>
" to the initial-state leptons involving at least one W, Z, "<>
" or Goldstone boson should be taken into account.";

dv::usage = "Specifies which orders of the hard current matching coefficient"<>
" are taken into account.";
ca::usage = "Specifies which orders of the P-wave hard current"<>
" matching coefficient are taken into account.";

AllContributions::usage =
"AllContributions is a list where all orders of all potentials are switched on.";
NoContributions::usage =
"NoContributions is a list where all orders of all potentials are switched off.";
ExceptContributions::usage =
"ExceptContributions[pot1 -> {vals1}, pot2 -> {vals2}, ...] returns a list"<>
" where all orders of all potentials except pot1, pot2, ... are switched on."<>
" pot1, pot2, ... are instead set to the specified values.";
OnlyContributions::usage =
"OnlyContributions[pot1 -> {vals1}, pot2 -> {vals2}, ...] returns a list"<>
" where all orders of all potentials except pot1, pot2, ... are switched off."<>
" pot1, pot2, ... are instead set to the specified values.";

IsShiftedMass::usage = "IsShiftedMass[s] returns True if"<>
" the mass difference between the scheme s and the Pole scheme"<>
" is expanded in the strong coupling and False otherwise";
BottomPoleMass::usage = "BottomPoleMass[mu, mb, o] gives the pole mass "<>
" corresponding to a bottom quark mass in a different scheme "<>
" specified by the options. "<>
" The conversion is performed at order at the scale mu.";
TopPoleMass::usage = "TopPoleMass[mu, mb, o] gives the pole mass "<>
" corresponding to a top quark mass in a different scheme "<>
" specified by the options. "<>
" The conversion is performed at order at the scale mu.";

BBbarThreshold::usage =
"BBbarThreshold[mu,mb,o] gives the center-of-mass energy"<>
" of the bottom pair production threshold for a bottom mass mb and scale mu.";
TTbarThreshold::usage =
"TTbarThreshold[mu,mt,o] gives the center-of-mass energy"<>
" of the top pair production threshold for a top mass mt and scale mu.";
QQbarThreshold::usage =
"Symbol that will be replaced by the center-of-mass energy of the"<>
" respective quark pair production threshold"<>
" when used inside the first argument to a cross section function.";

TopInternalSettings::usage =
"TopInternalSettings[E, {mu, muWeak}, {mt, width}, ord] or"<>
" TopInternalSettings[mu, mt,  ord] returns a String "<>
" with the names and values of variables used internally "<>
" by top-related functions.";

BottomInternalSettings::usage =
"BottomInternalSettings[E, mu, mb, ord] or BottomInternalSettings[mu, mb,  ord]"<>
" returns a String with the names and values of variables used internally "<>
" by bottom-related functions.";

alphaSmZDefault::usage = "Default value for strong coupling at the scale mZ.";
alphamZ::usage = "QED coupling at the scale mZ.";
alphaY::usage = "QED coupling at the scale muAlphaY.";
muAlphaY::usage = "Typical scale for Y resonances.";
mZ::usage = "Mass of the Z boson.";
mW::usage = "Mass of the W boson.";
mHiggsDefault::usage = "Default value for mass of the Higgs boson.";
alphaQED::usage = "Fine structure constant.";
eU::usage =
"Electric charge of up-type quarks in units of the positron charge.";
eD::usage =
"Electric charge of down-type quarks in units of the positron charge.";
eE::usage = "Electric charge of the electron in units of the positron charge.";
cw2::usage = "cosine of the weak mixing angle squared.";
sw2::usage = "sine of the weak mixing angle squared.";
GF::usage =
"Fermi constant. This is exclusively used for calculating the top width.";

T3Nu::usage = "Weak isospin of neutrino.";
T3E::usage = "Weak isospin of electron.";
T3U::usage = "Weak isospin of up-type quarks.";
T3D::usage = "Weak isospin of down-type quarks.";

mbSI::usage = "Reference scale-invariant mass for bottom quarks.";
muThr::usage = "Decoupling threshold for bottom quarks.";

nlBottom::usage = "Number of light flavours for bottom-related functions.";
nlTop::usage = "Number of light flavours for top-related functions.";

mufBottom::usage = "Default PS scale for bottom.";
mufTop::usage = "Default PS scale for top.";

InvGeV2ToPb = "Conversion factor from 1/GeV^2 to picobarn.";

Begin["`Private`"];

AllContributions = {
   vCoulomb  -> {1, 1, 1},
   vdelta -> {1, 1},
   vr2inv -> {1, 1},
   vp2 -> {1, 1},
   vkinetic -> {1},
   ultrasoft -> {1},
   vHiggs -> {1},
   vQEDCoulomb -> {1},
   cv -> {1, 1, 1},
   cvHiggs -> {1, 1},
   CvQED -> {1},
   CvWZ -> {1},
   CaQED -> {1},
   CaWZ -> {1},
   dv -> {1, 1},
   ca -> {1}
};

NoContributions = AllContributions /. 1 -> 0;

ExceptContributions[{pots___}] := ExceptContributions[pots];
ExceptContributions[pots___] := Join[
   {pots},
   Complement[AllContributions, FilterRules[AllContributions, {pots}]]
];

OnlyContributions[{pots___}] := OnlyContributions[pots];
OnlyContributions[pots___] := Join[
   {pots},
   Complement[NoContributions, FilterRules[NoContributions, {pots}]]
];

RealQ = Internal`RealValuedNumericQ;

FilterOptions::usage = "f_[args___,FilterOptions[opts__]] returns f[args,fopts],"<>
" where fopts are those options from opts that are actually known to f."<>
" FilterOptions[g_, opts___] adds the default options assigned to the Symbol g.";

FilterOptions /: f_[args___, FilterOptions[g_Symbol, opts___]] :=
f[args, FilterOptions@@(
   {opts}~Join~Complement[Options[g], FilterRules[Options[g], {opts}]]
)];

FilterOptions /: f_[args___, FilterOptions[opts___]] :=
f[args, Sequence@@FilterRules[{opts}, Options[f]]];


ConvertGrid[oldgrid_, newgrid_] := Module[
   {grid},
   grid = Take[#,28] & /@ Flatten[Get[oldgrid], 1];
   Export[newgrid, grid, "TSV"];
];

LoadGrid = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "load_grid",{"UTF8String"}, "Void"
];

LoadNonresonantGrid = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "load_nonresonant_grid",{"UTF8String"}, "Void"
];

GridEtMin = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "Et_min",{}, Real
];
GridEtMax = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "Et_max",{}, Real
];
GridGammatMin = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "Gammat_min",{}, Real
];
GridGammatMax = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "Gammat_max",{}, Real
];

Options[ContributionsToList] = AllContributions;

Options[BBbarXSection] = {
   alpha -> alphaY,
   muAlpha -> muAlphaY,
   BeyondQCD -> "QED",
   MassScheme -> {"PSshift", 2},
   Production -> All,
   ResumPoles -> 6,
   ResonantOnly -> True,
   ExpandEnergyFactor -> False,
   mHiggs -> mHiggsDefault,
   YukawaFactor -> 0,
   ml -> 0,
   r4 -> 1220.3,
   Contributions -> All,
   alphaSmZ -> alphaSmZDefault,
   alphaSmu0 -> Automatic
};

Options[BBbarRRatio] = Options[BBbarXSection];

Options[BBbarEnergyLevel] = Join[
   FilterRules[
      Options[BBbarXSection],
      {mHiggs, alphaSmZ, alphaSmu0, MassScheme, Contributions, ml, r4, alpha, YukawaFactor, BeyondQCD}
   ],
   {DoubleLightInsertion -> False}
];

Options[BBbarResidue] = Join[
   FilterRules[
      Options[BBbarXSection],
      {mHiggs, alphaSmZ, alphaSmu0, MassScheme, ExpandEnergyFactor, Contributions, ml, r4, alpha, YukawaFactor, BeyondQCD}
   ],
   {DoubleLightInsertion -> False}
];

Options[BottomPoleMass] = Options[BBbarEnergyLevel];

Options[BBbarThreshold] = Options[BottomPoleMass];

Options[TTbarXSection] = {
   alpha -> alphamZ,
   muAlpha -> mZ,
   BeyondQCD -> All,
   MassScheme -> {"PSshift", 20},
   Production -> All,
   ResumPoles -> 6,
   ResonantOnly -> False,
   ExpandEnergyFactor -> True,
   mHiggs -> mHiggsDefault,
   YukawaFactor -> 1,
   InvariantMassCut -> Automatic,
   ml -> 0,
   r4 -> 824.12,
   Contributions -> All,
   alphaSmZ -> alphaSmZDefault,
   alphaSmu0 -> Automatic
};

Options[TTbarRRatio] = Options[TTbarXSection];

Options[TTbarEnergyLevel] = Join[
   FilterRules[
      Options[TTbarXSection],
      {mHiggs, alphaSmZ, alphaSmu0, MassScheme, Contributions, ml, r4, alpha, YukawaFactor, BeyondQCD}
   ],
   {DoubleLightInsertion -> False}
];

Options[TTbarResidue] = Join[
   FilterRules[
      Options[TTbarXSection],
      {mHiggs, alphaSmZ, alphaSmu0, MassScheme, ExpandEnergyFactor, Contributions, ml, r4, alpha, YukawaFactor, BeyondQCD}
   ],
   {DoubleLightInsertion -> False}
];

Options[TopPoleMass] = Options[TTbarEnergyLevel];

Options[TTbarThreshold] = Options[TopPoleMass];

ThrList[thr_List] := Flatten[thr /. {} -> {0,0}];

alphaSBottom[mu_?RealQ] := asBottom[mu, mZ, alphaSmZDefault];

alphaSBottom[mu_?RealQ, asmZ_?RealQ] := asBottom[mu, mZ, asmZ];

alphaSBottom[mu_?RealQ, {mu0_?RealQ, alphaSmu0_?RealQ}] := asBottom[
   mu, mu0, alphaSmu0
];

alphaSTop[mu_?RealQ] := asTop[mu, mZ, alphaSmZDefault];

alphaSTop[mu_?RealQ, asmZ_?RealQ] := asTop[mu, mZ, asmZ];

alphaSTop[mu_?RealQ, {mu0_?RealQ, alphaSmu0_?RealQ}] := asTop[
   mu, mu0, alphaSmu0
];

BBbarXSection[energy_, args___, opts:OptionsPattern[]] := BBbarXSection[
   energy /. QQbarThreshold -> BBbarThreshold[args, FilterOptions[opts]],
   args,
   opts
] /; !FreeQ[energy, QQbarThreshold];

BBbarXSection[
   energy_?RealQ, scale_?RealQ, mass_?RealQ, order_String,
   opts:OptionsPattern[]
] := bbxs[
   energy, scale, mass, orderToInt[order],
   Sequence @@ BottomOptsToArgs[scale, opts]
];

BBbarRRatio[energy_, args___, opts:OptionsPattern[]] := BBbarRRatio[
   energy /. QQbarThreshold -> BBbarThreshold[args, FilterOptions[opts]],
   args,
   opts
] /; !FreeQ[energy, QQbarThreshold];

BBbarRRatio[
   energy_?RealQ, scale_?RealQ, mass_?RealQ, order_String,
   opts:OptionsPattern[]
] := Rb[
   energy, scale, mass, orderToInt[order],
   Sequence @@ BottomOptsToArgs[scale, opts]
];

TTbarXSection[
   energy_, scale_, {mass_, width_}, order_,
   opts:OptionsPattern[]
] := TTbarXSection[
   energy /. QQbarThreshold -> TTbarThreshold[scale, mass, orderToInt[order], FilterOptions[opts]],
   scale,
   {mass, width},
   orderToInt[order],
   opts
] /; !FreeQ[energy, QQbarThreshold];

TTbarXSection[
   energy_?RealQ, scale_?RealQ, {mass_?RealQ, width_?RealQ}, order_String,
   opts:OptionsPattern[]
] := ttxs[
   energy, scale, scale, mass, width, orderToInt[order],
   Sequence @@ TopOptsToArgs[scale, opts]
];

TTbarXSection[
   energy_?RealQ,
   {softscale_?RealQ, weakscale_?RealQ},
   {mass_?RealQ, width_?RealQ},
   order_String,
   opts:OptionsPattern[]
] := ttxs[
   energy, softscale, weakscale, mass, width, orderToInt[order],
   Sequence @@ TopOptsToArgs[scale, opts]
];

TTbarRRatio[
   energy_, scale_, {mass_, width_}, order_,
   opts:OptionsPattern[]
] := TTbarRRatio[
   energy /. QQbarThreshold -> TTbarThreshold[scale, mass, orderToInt[order], FilterOptions[opts]],
   scale,
   {mass, width},
   orderToInt[order],
   opts
] /; !FreeQ[energy, QQbarThreshold];

TTbarRRatio[
   energy_?RealQ, scale_?RealQ, {mass_?RealQ, width_?RealQ}, order_String,
   opts:OptionsPattern[]
] := Rt[
   energy, scale, scale, mass, width, orderToInt[order],
   Sequence @@ TopOptsToArgs[scale, opts]
];

TTbarRRatio[
   energy_?RealQ,
   {softscale_?RealQ, weakscale_?RealQ},
   {mass_?RealQ, width_?RealQ},
   order_String,
   opts:OptionsPattern[]
] := Rt[
   energy, softscale, weakscale, mass, width, orderToInt[order],
   Sequence @@ TopOptsToArgs[scale, opts]
];

BBbarEnergyLevel[
   n_Integer, scale_?RealQ, mass_?RealQ, order_String, opts:OptionsPattern[]
] := bbE[
   n, scale, mass, orderToInt[order],
   Sequence @@ BottomOptsToArgs[scale, opts]
];

TTbarEnergyLevel[
   n_Integer, scale_?RealQ, mass_?RealQ, order_String, opts:OptionsPattern[]
] := ttE[
   n, scale, mass, orderToInt[order],
   Sequence @@ TopOptsToArgs[scale, opts]
];

BBbarResidue[
   n_Integer, scale_?RealQ, mass_?RealQ, order_String, opts:OptionsPattern[]
] := bbZ[
   n, scale, mass, orderToInt[order],
   Sequence @@ BottomOptsToArgs[scale, opts]
];

TTbarResidue[
   n_Integer, scale_?RealQ, mass_?RealQ, order_String, opts:OptionsPattern[]
] :=  ttZ[
   n, scale, mass, orderToInt[order],
   Sequence @@ TopOptsToArgs[scale, opts]
];

TopWidth[
   scale_?RealQ, mass_?RealQ, order_String, opts:OptionsPattern[]
] :=  twidth[
   scale, mass, orderToInt[order],
   Sequence @@ TopOptsToArgs[scale, opts]
];

BottomPoleMass[
   scale_?RealQ, mass_?RealQ, order_String, opts:OptionsPattern[]
] := mpoleBottom[
   scale, mass, orderToInt[order],
   Sequence @@ BottomOptsToArgs[scale, opts]
];

TopPoleMass[
   scale_?RealQ, mass_?RealQ, order_String, opts:OptionsPattern[]
] := mpoleTop[
   scale, mass, orderToInt[order],
   Sequence @@ TopOptsToArgs[scale, opts]
];

BBbarThreshold[
   scale_?RealQ, mass_?RealQ, order_String, opts:OptionsPattern[]
] := bbbarthr[
   scale, mass, orderToInt[order],
   Sequence @@ BottomOptsToArgs[scale, opts]
];

TTbarThreshold[
   scale_?RealQ, mass_?RealQ, order_String, opts:OptionsPattern[]
] := ttbarthr[
   scale, mass, orderToInt[order],
   Sequence @@ TopOptsToArgs[scale, opts]
];

TopOptsToArgs::usage = "TopOptsToArgs[opts] converts the Options opts "<>
" to a list of arguments for the top-related LibraryFunctions "<>
" in libQQbar_threshold_mathematica";

Options[TopOptsToArgs] = Union[Flatten[
      Options /@ ToExpression /@
      Names["QQbarThreshold`TTbar*" | "QQbarThreshold`Top*"]
]];

TopOptsToArgs[scale_, OptionsPattern[]] := {
   schemeScale[OptionValue[MassScheme]],
   OptionValue[ResumPoles],
   SMToInt[OptionValue[BeyondQCD]],
   schemeToInt[OptionValue[MassScheme]],
   ProductionToInt[OptionValue[Production]],
   OptionValue[ResonantOnly],
   OptionValue[ExpandEnergyFactor],
   OptionValue[DoubleLightInsertion],
   OptionValue[mHiggs],
   OptionValue[YukawaFactor],
   InvariantMassCutToReal[OptionValue[InvariantMassCut]],
   OptionValue[ml],
   OptionValue[r4],
   OptionValue[alpha],
   OptionValue[muAlpha],
   Sequence @@ AlphaSOptsToArgs[OptionValue[alphaSmu0], OptionValue[alphaSmZ]],
   Sequence @@ ContributionsToList[OptionValue[Contributions]]
};

AlphaSOptsToArgs[{mu0_, as0_}, _] := {mu0, as0};
AlphaSOptsToArgs[_, asmZ_] := {mZ, asmZ};

Options[TopInternalSettings] = Options[TopOptsToArgs];

TopInternalSettings[
   energy_?RealQ, scale_?RealQ, {mass_?RealQ, width_?RealQ}, order_String,
   opts:OptionsPattern[]
] := TopSettings6[
   energy, scale, scale, mass, width, orderToInt[order],
   Sequence @@ TopOptsToArgs[scale, opts]
];

TopInternalSettings[
   energy_?RealQ, {softscale_?RealQ, weakscale_?RealQ},
   {mass_?RealQ, width_?RealQ}, order_String,
   opts:OptionsPattern[]
] := TopSettings6[
   energy, softscale, weakscale, mass, width, orderToInt[order],
   Sequence @@ TopOptsToArgs[scale, opts]
];

TopInternalSettings[
   scale_?RealQ, mass_?RealQ, order_String,
   opts:OptionsPattern[]
] := TopSettings3[
   scale, mass, orderToInt[order],
   Sequence @@ TopOptsToArgs[scale, opts]
];

BottomOptsToArgs::usage = "BottomOptsToArgs[opts] converts the Options opts "<>
" to a list of arguments for the bottom-related LibraryFunctions "<>
" in libQQbar_threshold_mathematica";

Options[BottomOptsToArgs] = Union[Flatten[
      Options /@ ToExpression /@
      Names["QQbarThreshold`BBbar*" | "QQbarThreshold`Bottom*"]
]];
Options[BottomInternalSettings] = Options[BottomOptsToArgs];

BottomOptsToArgs[scale_, OptionsPattern[]] := {
   schemeScale[OptionValue[MassScheme]],
   OptionValue[ResumPoles],
   SMToInt[OptionValue[BeyondQCD]],
   schemeToInt[OptionValue[MassScheme]],
   ProductionToInt[OptionValue[Production]],
   OptionValue[ResonantOnly],
   OptionValue[ExpandEnergyFactor],
   OptionValue[DoubleLightInsertion],
   OptionValue[mHiggs],
   OptionValue[YukawaFactor],
   0 (* unused *),
   OptionValue[ml],
   OptionValue[r4],
   OptionValue[alpha],
   OptionValue[muAlpha],
   Sequence @@ AlphaSOptsToArgs[OptionValue[alphaSmu0], OptionValue[alphaSmZ]],
   Sequence @@ ContributionsToList[OptionValue[Contributions]]
};

Options[BottomInternalSettings] = Options[BottomOptsToArgs];

BottomInternalSettings[
   energy_?RealQ, scale_?RealQ, mass_?RealQ, order_String,
   opts:OptionsPattern[]
] := BottomSettings4[
   energy, scale, mass, orderToInt[order],
   Sequence @@ BottomOptsToArgs[scale, opts]
];

BottomInternalSettings[
   scale_?RealQ, mass_?RealQ, order_String,
   opts:OptionsPattern[]
] := BottomSettings3[
   scale, mass, orderToInt[order],
   Sequence @@ BottomOptsToArgs[scale, opts]
];


IsShiftedMass[scheme_String] := isshifted[schemeToInt[scheme]];

isshifted = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "is_shifted_mass", {
   Integer
 },
 True|False
];

ContributionsToList[OptionsPattern[]] := Flatten[{
   OptionValue[vCoulomb],
   OptionValue[vdelta],
   OptionValue[vr2inv],
   OptionValue[vp2],
   OptionValue[vkinetic],
   OptionValue[ultrasoft],
   OptionValue[vHiggs],
   OptionValue[vQEDCoulomb],
   OptionValue[cv],
   OptionValue[cvHiggs],
   OptionValue[CvQED],
   OptionValue[CvWZ],
   OptionValue[CaQED],
   OptionValue[CaWZ],
   OptionValue[dv],
   OptionValue[ca]
}];

ContributionsToList[All] = ContributionsToList[AllContributions];

schemeToInt[{scheme_String, _}] := schemeToInt[scheme];

schemeToInt[{scheme_String}] := schemeToInt[scheme];

schemeToInt[scheme_String] := Switch[
   scheme,
   "PS", 0,
   "PSshift", 1,
   "1S", 2,
   "1Sshift", 3,
   "Pole", 4,
   "MSshift" | "MSbarshift" | "MSbar" , 5
];

orderToInt[order_String] := Switch[
   order,
   "LO", 0,
   "NLO", 1,
   "N2LO"|"NNLO", 2,
   "N3LO"|"NNNLO", 3
];

FlavourTop = 0;
FlavourBottom = 1;

ProductionToInt["PhotonOnly"] = 0;
ProductionToInt["SWaveOnly"] = 1;
ProductionToInt["All"] = 2;
ProductionToInt[All] = 2;

SMtoInt::cmb = "Illegal combination of beyond QCD corrections: `1`."<>
" Only \"Higgs\" and \"QED\" may be combined in a List.";
SMToInt[{x_}] := SMToInt[x];
SMToInt[{}] = SMToInt["None"] = SMToInt[None] = 0;
SMToInt["QED"] = 2^0;
SMToInt["Higgs"] = 2^1;
SMToInt["All"] = SMToInt[All] = 2^3 - 1;

SMToInt[{"QED", "Higgs"}] =
   SMToInt[{"Higgs", "QED"}] = SMToInt["QED"] + SMToInt["Higgs"];
SMToInt[{x_, y__}] := Message[SMtoInt::cmb, {x, y}];

InvariantMassCutToReal[Automatic] = -1;
InvariantMassCutToReal[x_?NonNegative] := x;

MassScheme::NoScale = "Scheme `1` requires a scale";
schemeScale[{_, x_}] := x;
schemeScale["1S"|"1Sshift"|"Pole"] := 0;
schemeScale[{scheme_}] := schemeScale[scheme];
schemeScale[scheme_] := (
   Message[MassScheme::NoScale, scheme];
   Null
);

asBottom = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "alpha_s_bottom", {
   Real, Real, Real
 },
 Real
];

asTop = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "alpha_s_top", {
   Real, Real, Real
 },
 Real
];

OptTypes = Sequence[
   Real, Integer ,Integer, Integer, Integer,
   True|False, True|False, True|False,
   Real, Real, Real, Real, Real, Real, Real,
   (* alpha_s *)
   Real, Real,
   (* contributions *)
   Real, Real, Real, Real, Real, Real, Real, Real,
   Real, Real, Real, Real, Real, Real, Real, Real,
   Real, Real, Real, Real, Real, Real, Real, Real,
   Real
];

OptTypes::Length =
"Internal error: incompatible lengths of argument lists
OptTypes: `1`
TopOptsToArgs: `2`
BottomOptsToArgs: `3`
";
If[! (
      Length[{OptTypes}] ===
      Length[TopOptsToArgs[Null]] ===
      Length[BottomOptsToArgs[Null]]
   ),
   Message[
      OptTypes::Length,
      Length[{OptTypes}],
      Length[TopOptsToArgs[Null]],
      Length[BottomOptsToArgs[Null]]
   ];
   Abort[]
];

bbxs = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "bbbar_xsection", {
   Real, Real, Real, Integer,
   OptTypes
   },
   Real
];

Rb = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "bbbar_R_ratio", {
   Real, Real, Real, Integer,
   OptTypes
   },
   Real
];

ttxs = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "ttbar_xsection", {
   Real, Real, Real, Real, Real, Integer,
   OptTypes
   },
   Real
];

Rt = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "ttbar_R_ratio", {
   Real, Real, Real, Real, Real, Integer,
   OptTypes
   },
   Real
];

bbE = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "bbbar_energy_level", {
   Integer, Real, Real, Integer,
   OptTypes
   },
   Real
];

ttE = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "ttbar_energy_level", {
   Integer, Real, Real, Integer,
   OptTypes
   },
   Real
];

twidth = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "top_width", {
   Real, Real, Integer,
   OptTypes
   },
   Real
];

bbZ = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "bbbar_residue", {
   Integer, Real, Real, Integer,
   OptTypes
   },
   Real
];

ttZ = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "ttbar_residue", {
   Integer, Real, Real, Integer,
   OptTypes
   },
   Real
];

mpoleBottom = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "bottom_pole_mass", {
   Real, Real, Integer,
   OptTypes
   },
   Real
];

mpoleTop = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "top_pole_mass", {
   Real, Real, Integer,
   OptTypes
   },
   Real
];

bbbarthr = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "bbbar_threshold", {
   Real, Real, Integer,
   OptTypes
   },
   Real
];

ttbarthr = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "ttbar_threshold", {
   Real, Real, Integer,
   OptTypes
   },
   Real
];

TopSettings3 = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "top_internal_settings_3", {
   Real, Real, Integer,
   OptTypes
   },
   "UTF8String"
];

BottomSettings3 = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "bottom_internal_settings_3", {
   Real, Real, Integer,
   OptTypes
   },
   "UTF8String"
];

BottomSettings4 = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "bottom_internal_settings_4", {
   Real, Real, Real, Integer,
   OptTypes
   },
   "UTF8String"
];

TopSettings6 = LibraryFunctionLoad[
   "libQQbar_threshold_mathematica",
   "top_internal_settings_6", {
   Real, Real, Real, Real, Real, Integer,
   OptTypes
   },
   "UTF8String"
];

End[];
Protect["QQbarThreshold`*"];
EndPackage[];
